package com.ejie.ad74a.service;

import java.io.IOException;
import java.io.OutputStream;
import java.lang.reflect.Field;
import java.lang.reflect.InvocationTargetException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.List;
import java.util.Locale;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.commons.beanutils.BeanUtils;
import org.apache.poi.hssf.usermodel.HSSFWorkbook;
import org.apache.poi.ss.usermodel.Cell;
import org.apache.poi.ss.usermodel.CellStyle;
import org.apache.poi.ss.usermodel.CreationHelper;
import org.apache.poi.ss.usermodel.Font;
import org.apache.poi.ss.usermodel.HorizontalAlignment;
import org.apache.poi.ss.usermodel.Row;
import org.apache.poi.ss.usermodel.Sheet;
import org.apache.poi.ss.usermodel.Workbook;
import org.apache.poi.xssf.usermodel.XSSFWorkbook;
import org.odftoolkit.odfdom.doc.OdfSpreadsheetDocument;
import org.odftoolkit.odfdom.doc.table.OdfTable;
import org.odftoolkit.odfdom.doc.table.OdfTableRow;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.i18n.LocaleContextHolder;
import org.springframework.context.support.ReloadableResourceBundleMessageSource;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.ejie.ad74a.constantes.Constantes;
import com.ejie.ad74a.dao.ValoracionesDao;
import com.ejie.ad74a.model.Valoraciones;
import com.ejie.ad74a.util.comun.UtilLiterales;
import com.ejie.ad74a.util.comun.UtilidadesFecha;
import com.ejie.ad74a.util.constantes.Constantes.NivelMaltratoEnum;
import com.ejie.ad74a.util.constantes.Constantes.NivelSuicidioEnum;
import com.ejie.ad74a.util.constantes.ModoValoracionEnum;
import com.ejie.ad74a.util.constantes.TipoMotivoRetrasoEnum;
import com.ejie.ad74a.util.constantes.TipoNivelSoporteEnum;
import com.ejie.ad74a.util.constantes.TipoValoracionEnum;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRequestDto;
import com.ejie.x38.dto.TableResponseDto;
import com.ejie.x38.dto.TableRowDto;
import com.ejie.x38.util.DateTimeManager;
import com.lowagie.text.Document;
import com.lowagie.text.Phrase;
import com.lowagie.text.pdf.PdfPCell;
import com.lowagie.text.pdf.PdfPTable;
import com.lowagie.text.pdf.PdfWriter;

/**
 * ValoracionesServiceImpl generated by UDA, 21-mar-2023 11:41:04.
 * 
 * @author UDA
 */

@Service(value = "valoracionesService")
public class ValoracionesServiceImpl implements ValoracionesService {

	@Autowired
	private ValoracionesDao valoracionesDao;

	@Resource
	private ReloadableResourceBundleMessageSource appMessageSource;

	/**
	 * Inserts a single row in the Valoraciones table.
	 *
	 * @param valoraciones Valoraciones
	 * @return Valoraciones
	 */
	@Transactional(rollbackFor = Throwable.class)
	public Valoraciones add(Valoraciones valoraciones) {
		return this.valoracionesDao.add(valoraciones);
	}

	/**
	 * Anyade una nueva valoracion, pasando a historico el resto
	 * 
	 * @param valoraciones
	 * @param usuHistorico
	 * @return
	 */
	@Transactional(rollbackFor = Throwable.class)
	public Valoraciones addNewValoracion(Valoraciones valoraciones, String usuHistorico) {
		Valoraciones valSolicitante = new Valoraciones();
		valSolicitante.setIdSolicitante08(valoraciones.getIdSolicitante08());
		List<Valoraciones> listaValoraciones = this.valoracionesDao.findAll(valSolicitante, null);
		if (null != listaValoraciones && !listaValoraciones.isEmpty()) {
			for (Valoraciones val : listaValoraciones) {
				if (null == val.getfHistorico08()) {
					val.setUsuHistorico08(usuHistorico);
					this.valoracionesDao.pasarHistorico(val);
				}
			}
		}
		return this.valoracionesDao.add(valoraciones);
	}

	/**
	 * Updates a single row in the Valoraciones table.
	 *
	 * @param valoraciones Valoraciones
	 * @return Valoraciones
	 */
	@Transactional(rollbackFor = Throwable.class)
	public Valoraciones update(Valoraciones valoraciones) {
		return this.valoracionesDao.update(valoraciones);
	}

	/**
	 * Finds a single row in the Valoraciones table.
	 *
	 * @param valoraciones Valoraciones
	 * @return Valoraciones
	 */
	public Valoraciones find(Valoraciones valoraciones) {
		return (Valoraciones) this.valoracionesDao.find(valoraciones);
	}

	/**
	 * Deletes a single row in the Valoraciones table.
	 *
	 * @param valoraciones Valoraciones
	 */
	@Transactional(rollbackFor = Throwable.class)
	public void remove(Valoraciones valoraciones) {
		this.valoracionesDao.remove(valoraciones);
	}

	/**
	 * Finds a list of rows in the Valoraciones table.
	 *
	 * @param valoraciones    Valoraciones
	 * @param tableRequestDto TableRequestDto
	 * @return List<Valoraciones>
	 */
	public List<Valoraciones> findAll(Valoraciones valoraciones, TableRequestDto tableRequestDto) {
		return (List<Valoraciones>) this.valoracionesDao.findAll(valoraciones, tableRequestDto);
	}

	/**
	 * Finds rows in the Valoraciones table using like.
	 *
	 * @param valoraciones    Valoraciones
	 * @param tableRequestDto TableRequestDto
	 * @param startsWith      Boolean
	 * @return List<Valoraciones>
	 */
	public List<Valoraciones> findAllLike(Valoraciones valoraciones, TableRequestDto tableRequestDto,
			Boolean startsWith) {
		return (List<Valoraciones>) this.valoracionesDao.findAllLike(valoraciones, tableRequestDto, startsWith);
	}

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Removes rows from the Valoraciones table.
	 *
	 * @param tableRequestDto TableRequestDto
	 */
	public void removeMultiple(TableRequestDto tableRequestDto) {
		this.valoracionesDao.removeMultiple(tableRequestDto);
	}

	/**
	 * Filter method in the Valoraciones table.
	 *
	 * @param filterValoraciones Valoraciones
	 * @param tableRequestDto    TableRequestDto
	 * @param startsWith         Boolean
	 * @return TableResponseDto<Valoraciones>
	 */
	public TableResponseDto<Valoraciones> filter(Valoraciones filterValoraciones, TableRequestDto tableRequestDto,
			Boolean startsWith) {
		List<Valoraciones> listaValoraciones = this.valoracionesDao.findAllLike(filterValoraciones, tableRequestDto,
				false);
		Long recordNum = this.valoracionesDao
				.findAllLikeCount(filterValoraciones != null ? filterValoraciones : new Valoraciones(), false);

		TableResponseDto<Valoraciones> tableResponseDto = new TableResponseDto<Valoraciones>(tableRequestDto, recordNum,
				listaValoraciones);

		if (tableRequestDto.getMultiselection().getSelectedIds() != null) {
			List<TableRowDto<Valoraciones>> reorderSelection = this.valoracionesDao.reorderSelection(filterValoraciones,
					tableRequestDto, startsWith);
			tableResponseDto.setReorderedSelection(reorderSelection);
			tableResponseDto.addAdditionalParam("reorderedSelection", reorderSelection);
			tableResponseDto.addAdditionalParam("selectedAll", tableRequestDto.getMultiselection().getSelectedAll());
		}
		if (tableRequestDto.getSeeker().getSelectedIds() != null) {
			tableRequestDto.setMultiselection(tableRequestDto.getSeeker());
			List<TableRowDto<Valoraciones>> reorderSeeker = this.valoracionesDao.reorderSelection(filterValoraciones,
					tableRequestDto, startsWith);
			tableResponseDto.setReorderedSeeker(reorderSeeker);
			tableResponseDto.addAdditionalParam("reorderedSeeker", reorderSeeker);
		}
		return tableResponseDto;
	}

	/**
	 * FilterHistorico method in the Valoraciones table.
	 *
	 * @param filterValoraciones Valoraciones
	 * @param tableRequestDto    TableRequestDto
	 * @param startsWith         Boolean
	 * @return TableResponseDto<Valoraciones>
	 */
	public TableResponseDto<Valoraciones> filterHistorico(Valoraciones filterValoraciones,
			TableRequestDto tableRequestDto, Boolean startsWith) {
		List<Valoraciones> listaValoraciones = this.valoracionesDao.findAllLikeHistorico(filterValoraciones,
				tableRequestDto, false);
		Long recordNum = this.valoracionesDao
				.findAllLikeCountHistorico(filterValoraciones != null ? filterValoraciones : new Valoraciones(), false);

		TableResponseDto<Valoraciones> tableResponseDto = new TableResponseDto<Valoraciones>(tableRequestDto, recordNum,
				listaValoraciones);

		if (tableRequestDto.getMultiselection().getSelectedIds() != null) {
			List<TableRowDto<Valoraciones>> reorderSelection = this.valoracionesDao
					.reorderSelectionHistorico(filterValoraciones, tableRequestDto, startsWith);
			tableResponseDto.setReorderedSelection(reorderSelection);
			tableResponseDto.addAdditionalParam("reorderedSelection", reorderSelection);
			tableResponseDto.addAdditionalParam("selectedAll", tableRequestDto.getMultiselection().getSelectedAll());
		}
		if (tableRequestDto.getSeeker().getSelectedIds() != null) {
			tableRequestDto.setMultiselection(tableRequestDto.getSeeker());
			List<TableRowDto<Valoraciones>> reorderSeeker = this.valoracionesDao
					.reorderSelectionHistorico(filterValoraciones, tableRequestDto, startsWith);
			tableResponseDto.setReorderedSeeker(reorderSeeker);
			tableResponseDto.addAdditionalParam("reorderedSeeker", reorderSeeker);
		}
		return tableResponseDto;
	}

	/**
	 * Searches rows in the Valoraciones table.
	 *
	 * @param filterValoraciones Valoraciones
	 * @param searchValoraciones Valoraciones
	 * @param tableRequestDto    TableRequestDto
	 * @param startsWith         Boolean
	 * @return List<TableRowDto<Valoraciones>>
	 */
	public List<TableRowDto<Valoraciones>> search(Valoraciones filterValoraciones, Valoraciones searchValoraciones,
			TableRequestDto tableRequestDto, Boolean startsWith) {
		return this.valoracionesDao.search(filterValoraciones, searchValoraciones, tableRequestDto, startsWith);
	}

	/**
	 * Reorder the selection made in Valoraciones table.
	 *
	 * @param filterValoraciones Valoraciones
	 * @param tableRequestDto    TableRequestDto
	 * @param startsWith         Boolean
	 * @return Object
	 */
	public Object reorderSelection(Valoraciones filterValoraciones, TableRequestDto tableRequestDto,
			Boolean startsWith) {
		return this.valoracionesDao.reorderSelection(filterValoraciones, tableRequestDto, startsWith);
	}

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Finder method in the hierarchical the Valoraciones table.
	 *
	 * @param filterValoraciones Valoraciones
	 * @param tableRequestDto    TableRequestDto
	 * @param startsWith         Boolean
	 * @return TableResponseDto<JerarquiaDto<Valoraciones>>
	 */
	public TableResponseDto<JerarquiaDto<Valoraciones>> jerarquia(Valoraciones filterValoraciones,
			TableRequestDto tableRequestDto, Boolean startsWith) {
		List<JerarquiaDto<Valoraciones>> listaValoraciones = this.valoracionesDao
				.findAllLikeJerarquia(filterValoraciones, tableRequestDto);
		Long recordNum = this.valoracionesDao.findAllLikeCountJerarquia(filterValoraciones, tableRequestDto);
		return new TableResponseDto<JerarquiaDto<Valoraciones>>(tableRequestDto, recordNum, listaValoraciones);
	}

	/**
	 * Finder method for siblings rows in the hierarchical the Valoraciones table.
	 *
	 * @param filterValoraciones Valoraciones
	 * @param tableRequestDto    TableRequestDto
	 * @return TableResponseDto<JerarquiaDto<Valoraciones>>
	 */
	public TableResponseDto<JerarquiaDto<Valoraciones>> jerarquiaChildren(Valoraciones filterValoraciones,
			TableRequestDto tableRequestDto) {
		TableResponseDto<JerarquiaDto<Valoraciones>> tableResponseDto = new TableResponseDto<JerarquiaDto<Valoraciones>>();
		tableResponseDto.addAdditionalParam(TableResponseDto.CHILDREN,
				this.valoracionesDao.findAllChild(filterValoraciones, tableRequestDto));
		return tableResponseDto;
	}

	/**
	 * Exporta Datos al clipBoard
	 *
	 */
	public List<Valoraciones> getMultiple(Valoraciones filterValoraciones, TableRequestDto tableRequestDto,
			Boolean startsWith) {
		return this.valoracionesDao.getMultiple(filterValoraciones, tableRequestDto, startsWith);
	}

	/**
	 * Devuelve un fichero en el formato deseado que contiene los datos exportados
	 * de la tabla.
	 *
	 * @param filterValoraciones Valoraciones
	 * @param columns            String[]
	 * @param fileName           String
	 * @param sheetTitle         String
	 * @param reportsParams      ArrayList<?>
	 * @param tableRequestDto    TableRequestDto
	 * @param request            HttpServletRequest
	 * @param response           HttpServletResponse
	 */
	@Override
	public void generateReport(Valoraciones filterValoraciones, String[] columns, String[] columnsName, String fileName,
			String sheetTitle, TableRequestDto tableRequestDto, HttpServletRequest request,
			HttpServletResponse response) {
		// Accede a la DB para recuperar datos
		List<Valoraciones> filteredData = getDataForReports(filterValoraciones, tableRequestDto);
		String extension = null;

		// Comprobar si las siguientes variables estan vacias, en caso de estarlo se las
		// asigna un valor generico
		fileName = (fileName != null && !fileName.isEmpty()) ? fileName : "report";
		sheetTitle = (sheetTitle != null && !sheetTitle.isEmpty()) ? sheetTitle : Valoraciones.class.getSimpleName();

		// Obtener el formato de fecha especifico del locale
		SimpleDateFormat formatter = DateTimeManager.getDateTimeFormat(request.getLocale());

		// Cuando no se definen columnas porque se quieren obtener todas
		if (columns == null) {
			Field[] fields = Valoraciones.class.getDeclaredFields();
			ArrayList<String> tempColumns = new ArrayList<String>();

			for (int i = 0; i < fields.length; i++) {
				try {
					String methodName = fields[i].getName();
					methodName = methodName.substring(0, 1).toUpperCase() + methodName.substring(1);
					Valoraciones.class.getMethod("get" + methodName);
					tempColumns.add(fields[i].getName());
				} catch (NoSuchMethodException e) {
					e.printStackTrace();
				}

			}
			columns = tempColumns.toArray(new String[0]);
		}

		// si no se definen el nombre de las columnas , se dejan las de por defecto.
		if (columnsName == null) {
			columnsName = columns;
		}

		String servletPath = request.getServletPath();
		String reportType = null;
		if (servletPath.contains("/") && (servletPath.lastIndexOf("/") + 1 != servletPath.length())) {
			reportType = servletPath.substring(servletPath.lastIndexOf("/") + 1, servletPath.length());
		} else {
			reportType = servletPath.substring(0, servletPath.length());
		}

		if (reportType.equals("xlsReport")) {
			extension = ".xls";
			generateExcelReport(filteredData, columns, columnsName, fileName, sheetTitle, extension, formatter,
					response);
		} else if (reportType.equals("xlsxReport")) {
			extension = ".xlsx";
			generateExcelReport(filteredData, columns, columnsName, fileName, sheetTitle, extension, formatter,
					response);
		} else if (reportType.equals("pdfReport")) {
			extension = ".pdf";
			generatePDFReport(filteredData, columns, columnsName, fileName, response);
		} else if (reportType.equals("odsReport")) {
			extension = ".ods";
			generateODSReport(filteredData, columns, columnsName, fileName, sheetTitle, response);
		} else if (reportType.equals("csvReport")) {
			extension = ".csv";
			// Obtener idioma
			String language = request.getLocale().getLanguage();
			generateCSVReport(filteredData, columns, columnsName, fileName, sheetTitle, language, response);
		}

	}

	/**
	 * Devuelve un fichero excel que contiene los datos exportados de la tabla.
	 *
	 * @param filteredData List<Valoraciones>
	 * @param columns      String[]
	 * @param fileName     String
	 * @param sheetTitle   String
	 * @param extension    String
	 * @param formatter    SimpleDateFormat
	 * @param response     HttpServletResponse
	 */
	private void generateExcelReport(List<Valoraciones> filteredData, String[] columns, String[] columnsName,
			String fileName, String sheetTitle, String extension, SimpleDateFormat formatter,
			HttpServletResponse response) {
		try {
			// Creacion del Excel
			Workbook workbook = null;
			if (extension == ".xlsx") {
				workbook = new XSSFWorkbook();
				response.setContentType("application/vnd.openxmlformats-officedocument.spreadsheetml.sheet");
			} else {
				workbook = new HSSFWorkbook();
				response.setContentType("application/vnd.ms-excel");
			}

			response.setHeader("Content-Disposition", "attachment; filename=" + fileName + extension + "");

			// Creacion de una hoja y asignacion de su nombre
			Sheet sheet = workbook.createSheet(sheetTitle);

			// Se crea una fuente para estilizar las cabeceras
			Font headerFont = workbook.createFont();
			headerFont.setBold(true);
			headerFont.setFontHeightInPoints((short) 12);

			// Se crea un CellStyle con la fuente
			CellStyle headerCellStyle = workbook.createCellStyle();
			headerCellStyle.setAlignment(HorizontalAlignment.CENTER);
			headerCellStyle.setFont(headerFont);

			// Inicializar contador de filas
			int rowNumber = 0;

			// Se crea la fila para insertar los titulos de las columnas
			Row row = sheet.createRow(rowNumber++);

			// Añadir titulos
			for (int i = 0; i < columnsName.length; i++) {
				Cell cell = row.createCell(i);
				cell.setCellValue(
						UtilLiterales.getLiteralMessage(appMessageSource, "excelReportLiteral." + columnsName[i]));
				cell.setCellStyle(headerCellStyle);
			}

			// CreationHelper ayudara a mantener la compatibilidad del DataFormat tanto si
			// se crea un .xls como un .xlsx
			CreationHelper createHelper = workbook.getCreationHelper();

			// Se crea un CellStyle para añadir el formateador de fechas
			CellStyle dateCellStyle = workbook.createCellStyle();
			dateCellStyle.setDataFormat(createHelper.createDataFormat().getFormat(formatter.toPattern()));

			// Añadir datos
			for (Valoraciones rowValoraciones : filteredData) {
				int cellNumber = 0;
				row = sheet.createRow(rowNumber++);

				// Se iteran las columnas y se insertan los datos respetando el orden que tenian
				// las columnas en la tabla
				for (String column : columns) {
					Cell cellValoraciones = row.createCell(cellNumber++);
					cellValoraciones.setCellValue(getCellValue(column, rowValoraciones));
				}
			}

			// Se adapta el ancho de las columnas al contenido
			for (int i = 0; i < columns.length; i++) {
				sheet.autoSizeColumn(i);
			}

			// Se añade el fichero excel al response
			workbook.write(response.getOutputStream());
			workbook.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	/**
	 * Devuelve un fichero pdf que contiene los datos exportados de la tabla.
	 *
	 * @param filteredData List<Valoraciones>
	 * @param columns      String[]
	 * @param fileName     String
	 * @param response     HttpServletResponse
	 */
	private void generatePDFReport(List<Valoraciones> filteredData, String[] columns, String[] columnsName,
			String fileName, HttpServletResponse response) {
		try {
			// Se añade el fichero excel al response y se añade el contenido
			response.setHeader("Content-Disposition", "attachment; filename=" + fileName + ".pdf");
			response.setContentType("application/pdf");

			Document document = new Document();
			// Se añade el fichero pdf al response
			PdfWriter.getInstance(document, response.getOutputStream());

			document.open();

			PdfPTable table = new PdfPTable(columns.length);

			for (String column : columnsName) {
				PdfPCell header = new PdfPCell();
				header.setBorderWidth(2);
				header.setPhrase(new Phrase(column));
				table.addCell(header);
			}

			// Añadir datos
			for (Valoraciones rowValoraciones : filteredData) {
				// Se iteran las columnas y se insertan los datos respetando el orden que tenian
				// las columnas en la tabla
				for (String column : columns) {
					table.addCell(getCellValue(column, rowValoraciones));
				}
			}

			document.add(table);
			document.close();

		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	/**
	 * Devuelve un fichero ods que contiene los datos exportados de la tabla.
	 *
	 * @param filteredData List<Valoraciones>
	 * @param columns      String[]
	 * @param fileName     String
	 * @param sheetTitle   String
	 * @param response     HttpServletResponse
	 */
	private void generateODSReport(List<Valoraciones> filteredData, String[] columns, String[] columnsName,
			String fileName, String sheetTitle, HttpServletResponse response) {
		try {
			// Se añade el fichero ods al response y se añade el contenido
			response.setHeader("Content-Disposition", "attachment; filename=" + fileName + ".ods");
			response.setContentType("application/vnd.oasis.opendocument.spreadsheet");

			OdfSpreadsheetDocument ods = OdfSpreadsheetDocument.newSpreadsheetDocument();
			ods.getOrCreateDocumentStyles();

			// Hay que eliminar la hoja que se genera por defecto
			ods.getTableByName("Sheet1").remove();

			// Hoja nueva
			OdfTable table = OdfTable.newTable(ods, filteredData.size() + 1, columns.length);
			table.setTableName(sheetTitle);

			// Inicializar contador de filas
			int rowNumber = 0;

			// Cabeceras
			OdfTableRow row = table.getRowByIndex(rowNumber++);
			for (int i = 0; i < columnsName.length; i++) {
				row.getCellByIndex(i).setStringValue(columnsName[i]);
			}

			// Añadir datos
			for (Valoraciones rowValoraciones : filteredData) {
				row = table.getRowByIndex(rowNumber++);
				int cellNumber = 0;

				// Se iteran las columnas y se insertan los datos respetando el orden que tenian
				// las columnas en la tabla
				for (String column : columns) {
					row.getCellByIndex(cellNumber++).setStringValue(getCellValue(column, rowValoraciones));
				}
			}

			// Se añade el fichero ods al response
			ods.save(response.getOutputStream());
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	/**
	 * Devuelve un fichero csv que contiene los datos exportados de la tabla.
	 *
	 * @param filteredData List<Valoraciones>
	 * @param columns      String[]
	 * @param fileName     String
	 * @param sheetTitle   String
	 * @param language     String
	 * @param response     HttpServletResponse
	 */
	private void generateCSVReport(List<Valoraciones> filteredData, String[] columns, String[] columnsName,
			String fileName, String sheetTitle, String language, HttpServletResponse response) {
		try {
			// Se añade el fichero excel al response y se añade el contenido
			response.setHeader("Content-Disposition", "attachment; filename=" + fileName + ".csv");
			response.setContentType("text/csv");

			// Separador de campos dependiendo del idioma
			String separator = ";";
			if (language.equals("en")) {
				separator = ",";
			}

			// Se añade el fichero csv al response
			OutputStream out = response.getOutputStream();
			// Añadir titulos
			boolean addTitles = true;

			// Añadir datos
			for (Valoraciones rowValoraciones : filteredData) {
				int cellNumber = 1;
				StringBuilder columnsTitles = new StringBuilder();
				StringBuilder row = new StringBuilder();

				// Se iteran las columnas y se insertan los datos respetando el orden que tenian
				// las columnas en la tabla
				for (String column : columns) {
					String cellValue = getCellValue(column, rowValoraciones);

					if (cellNumber < columns.length) {
						if (addTitles) {
							columnsTitles.append("\"");
							columnsTitles.append(column);
							columnsTitles.append("\"");
							columnsTitles.append(separator);
						}
						row.append("\"");
						row.append(cellValue);
						row.append("\"");
						row.append(separator);
						cellNumber++;
					} else {
						if (addTitles) {
							columnsTitles.append("\"");
							columnsTitles.append(column);
							columnsTitles.append("\"\n");
						}
						row.append("\"");
						row.append(cellValue);
						row.append("\"\n");
					}
				}

				if (addTitles) {
					out.write(columnsTitles.toString().getBytes());
					addTitles = false;
				}
				out.write(row.toString().getBytes());
			}
			out.close();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	/**
	 * Devuelve los datos recuperados de la DB.
	 *
	 * @param filterValoraciones Valoraciones
	 * @param tableRequestDto    TableRequestDto
	 */
	private List<Valoraciones> getDataForReports(Valoraciones filterValoraciones, TableRequestDto tableRequestDto) {
		if (tableRequestDto.getMultiselection().getSelectedAll()
				&& tableRequestDto.getMultiselection().getSelectedIds().isEmpty()) {
			if (filterValoraciones != null) {
				return this.valoracionesDao.findAllLike(filterValoraciones, tableRequestDto, false);
			} else {
				return this.valoracionesDao.findAllLike(filterValoraciones, tableRequestDto, false);
			}
		} else {
			return this.valoracionesDao.findAllLike(filterValoraciones, tableRequestDto, false);
		}
	}

	/**
	 * Obtiene los valores de las celdas.
	 *
	 * @param column          String
	 * @param rowValoraciones Valoraciones
	 */
	private String getCellValue(String column, Valoraciones rowValoraciones) {
		String cellValue = "";
		try {
			if ("tipoValoracion08".equalsIgnoreCase(column)) {
				if (rowValoraciones.getTipoValoracion08() != null) {
					cellValue = TipoValoracionEnum.getDesc(String.valueOf(rowValoraciones.getTipoValoracion08()));
				} else {
					cellValue = BeanUtils.getProperty(rowValoraciones, column) != null
							? BeanUtils.getProperty(rowValoraciones, column)
							: "";
				}
				return cellValue;
			}
			if ("modoValoracion08".equalsIgnoreCase(column)) {
				if (rowValoraciones.getModoValoracion08() != null) {
					cellValue = ModoValoracionEnum.getDesc(String.valueOf(rowValoraciones.getModoValoracion08()));
				} else {
					cellValue = BeanUtils.getProperty(rowValoraciones, column) != null
							? BeanUtils.getProperty(rowValoraciones, column)
							: "";
				}
				return cellValue;
			}

			if ("fValoracion08".equalsIgnoreCase(column)) {
				cellValue = UtilidadesFecha.formatearDateToString(rowValoraciones.getfValoracion08());
				return cellValue;
			}

			if ("idNivelSoporte08".equalsIgnoreCase(column)) {
				if (rowValoraciones.getIdNivelSoporte08() != null) {
					cellValue = TipoNivelSoporteEnum.getDesc(String.valueOf(rowValoraciones.getIdNivelSoporte08()));
				} else {
					cellValue = BeanUtils.getProperty(rowValoraciones, column) != null
							? BeanUtils.getProperty(rowValoraciones, column)
							: "";
				}
				return cellValue;
			}

			if ("altoRiesgo08".equalsIgnoreCase(column)) {
				Locale locale = LocaleContextHolder.getLocale();
				if (rowValoraciones.getAltoRiesgo08() != null) {
					if (Constantes.UNO == rowValoraciones.getAltoRiesgo08()) {
						cellValue = UtilLiterales.getLiteralMessage(appMessageSource, locale, "comun.si");
					} else {
						cellValue = UtilLiterales.getLiteralMessage(appMessageSource, locale, "comun.no");
					}
				} else {
					cellValue = BeanUtils.getProperty(rowValoraciones, column) != null
							? BeanUtils.getProperty(rowValoraciones, column)
							: "";
				}
				return cellValue;
			}

			if ("nivelMaltrato08".equalsIgnoreCase(column)) {
				if (rowValoraciones.getNivelMaltrato08() != null) {
					cellValue = NivelMaltratoEnum.getDesc(rowValoraciones.getNivelMaltrato08());
				} else {
					cellValue = BeanUtils.getProperty(rowValoraciones, column) != null
							? BeanUtils.getProperty(rowValoraciones, column)
							: "";
				}
				return cellValue;
			}

			if ("nivelSuicidio08".equalsIgnoreCase(column)) {
				if (rowValoraciones.getNivelSuicidio08() != null) {
					cellValue = NivelSuicidioEnum.getDesc(rowValoraciones.getNivelSuicidio08());
				} else {
					cellValue = BeanUtils.getProperty(rowValoraciones, column) != null
							? BeanUtils.getProperty(rowValoraciones, column)
							: "";
				}
				return cellValue;
			}

			if ("motivoRetraso08".equalsIgnoreCase(column)) {
				if (rowValoraciones.getMotivoRetraso08() != null) {
					cellValue = TipoMotivoRetrasoEnum.getDesc(String.valueOf(rowValoraciones.getMotivoRetraso08()));

				} else {
					cellValue = BeanUtils.getProperty(rowValoraciones, column) != null
							? BeanUtils.getProperty(rowValoraciones, column)
							: "";
				}
				return cellValue;
			}

			cellValue = BeanUtils.getProperty(rowValoraciones, column) != null
					? BeanUtils.getProperty(rowValoraciones, column)
					: "";
		} catch (IllegalAccessException e) {
			e.printStackTrace();
		} catch (InvocationTargetException e) {
			e.printStackTrace();
		} catch (NoSuchMethodException e) {
			e.printStackTrace();
		}

		return cellValue;
	}

	@Override
	public Valoraciones updateTabPrestacionServicio(Valoraciones valoraciones) {
		return this.valoracionesDao.updateTabPrestacionServicio(valoraciones);
	}

	/**
	 * Obtiene la valoración actual de un solicitante
	 * 
	 * @param valoracion
	 * @return
	 */
	@Override
	public Valoraciones getSolCurrentValoracion(Valoraciones valoracion) {
		return this.valoracionesDao.getSolCurrentValoracion(valoracion);
	}

	/**
	 * Updates a single row in the Valoraciones table as historico.
	 *
	 * @param valoracion Valoraciones
	 * @return Valoraciones
	 */
	@Override
	public Valoraciones updateHistorico(Valoraciones valoracion) {
		return this.valoracionesDao.updateHistorico(valoracion);
	}

}
